function [x_y,e_xy,e_x] = resynth(X_lp,X_lp_conv,wavfile,pm_conv)
% y = resynth(X_lp,X_lp_conv,wavfile)

[x,fs] = wavread(['../data/source_down/t01',wavfile,'.wav']); % source
x = x*pow2(15);                                 % prevent underflow
[pm_x,~] = textread(['../data/source_pm/t01',wavfile,'.pm'],'%f%f','headerlines',9);
pm_x = round(pm_x*fs);                                 % seconds to samples
[x,pm_x] = strip_sil(x,pm_x);
pm_x(end) = [];

e_x = lpcifilt2(x,X_lp,pm_x);
[x_y,e_xy] = psolasynth(e_x,pm_conv,pm_x,X_lp_conv);

x_y = x_y./pow2(15);
x_y(x_y>0.4) = 0.4;
x_y(x_y<-0.4) = -0.4;
x_y = x_y-mean(x_y);

end