%% Voice Transformation
% Terje Gundersen
% June 2010

%% Read files
clear all;
close all;
clc;

N = 100;                                    % Number of sentences
[X_cc,Y_cc] = readfiles(N);
% [X_cc,Y_cc,f_vx,f_vy] = readfiles_v(N);
save('var/wavfiles','X_cc','Y_cc');
% save('var/wavfiles_v','X_cc','Y_cc','f_vx','f_vy');

%% Train GMM
clear all;
close all;
clc;
% load('var/wavfiles_v','f_vx','f_vy');     % load only voiced frames for F0             
load('var/wavfiles','X_cc','Y_cc');       % load all frames for cepstrum

m = 128;                                  % numer of mixture in diagonal GMM
% mp = 64;                                  % numer of mixture in full GMM
% gm_f0 = train_gmmf0f0(f_vx,f_vy,mp);      % GMM with z=[F0_x,F0_y]
% gm_f0 = train_gmmf0f0(f_vy,f_vx,mp);      % GMM with z=[F0_y,F0_x]
gm_obj = train_gmm(X_cc,m);               % GMM with z=[X_cc]
% gm_obj = train_gmm(Y_cc,m);               % GMM with z=[Y_cc]

save('var/gmm128','gm_obj');              
% save('var/gmm128_y','gm_obj');            
% save('var/gmmf0f0','gm_f0');            
% save('var/gmmf0f0_y','gm_f0');            

%% Training of Sigma_yx
clear all;
close all;
clc;
load('var/wavfiles','X_cc','Y_cc');
load('var/gmm128');
% load('var/gmm128_y');

[V,Gamma,sigma_diag] = training(gm_obj,X_cc,Y_cc);      % X to Y
% [V,Gamma,sigma_diag] = training(gm_obj,Y_cc,X_cc);      % Y to X

save('var/variables128','V','Gamma','sigma_diag');
% save('var/variables128_y','V','Gamma','sigma_diag');

%% Conversion of CC
clear all;
close all;
clc;
load('var/gmm128');
% load('var/gmm128_y');
load('var/variables128');
% load('var/variables128_y');
wavfile = 's016804';

[X_lp,X_lp_conv,X_cc_conv,ind_pm] = conversion(gm_obj,V,Gamma,sigma_diag,wavfile);

save('var/converted','X_lp','X_lp_conv','X_cc_conv','wavfile','ind_pm');
% save('var/converted_y','X_lp','X_lp_conv','X_cc_conv','wavfile','ind_pm');

%% Conversion of pitch markings
clear all;
close all;
clc;

load('var/wavfiles_v','f_vy');
f0_mean_y = mean(f_vy);
load('var/converted','ind_pm','wavfile');
load('var/gmmf0f0');

[x,fs] = wavread(['../data/source_down/t01',wavfile,'.wav']); % source
x = x*pow2(15);                                 % prevent underflow
[pm_x,~] = textread(['../data/source_pm/t01',wavfile,'.pm'],'%f%f','headerlines',9);
pm_x = round(pm_x*fs);                                 % seconds to samples
[f0_x,f2_x,~,~] = textread(['../data/source_f0/t01',wavfile,'.tf0'],'%f%f%f%f');
[x,pm_x,f1_x] = strip_sil(x,pm_x,f2_x,f0_x,fs);

temp_pm = pm_x(ind_pm);
fx = f1_x(temp_pm,2);

pm_conv = conversionf0f0(gm_f0,fx,f0_mean_y,ind_pm,length(pm_x));

% save('var/convertedf0f0','pm_conv');

%% Analysis and synthesis
clear all;
close all;
clc;
load('var/converted');
load('var/convertedf0f0');

x_conv = resynth(X_lp,X_lp_conv,wavfile,pm_conv);

% wavwrite(x_conv,8e3,'wav/s016804_20100608');